#include "splash-preferences.h"

#include "splash-tree-view.h"
#include "splash-image.h"

#include <glib-object.h>
#include <gtk/gtk.h>
#include <libgnomevfs/gnome-vfs-init.h>

G_DEFINE_TYPE (SplashPreferences,
	       splash_preferences,
	       GTK_TYPE_DIALOG);

static void
splash_preferences_init (SplashPreferences *prefs)
{
	GtkWidget *hbox, *treeview, *image;

	hbox = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (GTK_WIDGET (hbox));
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG (prefs)->vbox), hbox);

	treeview = splash_tree_view_new ();
	gtk_widget_show (GTK_WIDGET (treeview));
	gtk_box_pack_start (GTK_BOX (hbox), treeview, FALSE, FALSE, 0);

/*	maybe a simple GtkImage is enough, depending on how the treeview and the
	image interact.
	image = splash_image_new (GTK_TREE_VIEW (treeview));
	gtk_widget_show (GTK_WIDGET (image));
	gtk_container_add (GTK_CONTAINER (hbox), image);*/

	image = gtk_image_new ();
	gtk_widget_show (GTK_WIDGET (image));
	gtk_container_add (GTK_CONTAINER (hbox), image);

	g_signal_connect (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
			  "changed",
			  G_CALLBACK (splash_tree_selection_changed),
			  image);

	gtk_dialog_add_buttons (GTK_DIALOG (prefs),
				GTK_STOCK_HELP, GTK_RESPONSE_HELP,
				GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE,
				NULL);

	/* FIXME - should be fixed in GTK+ itself. Maybe 2.0 stuff */
	gtk_widget_ensure_style (GTK_WIDGET (prefs));
	gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (prefs)->vbox), 12);
	gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (prefs)->vbox), 12);
	gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (prefs)->action_area), 0);
	gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (prefs)->action_area), 6);
	gtk_dialog_set_has_separator (GTK_DIALOG (prefs), FALSE);
}

static void
splash_preferences_class_init (SplashPreferencesClass *class)
{
}

int
main (int    argc,
      char **argv)
{
	GtkDialog *prefs;

	gtk_init (&argc, &argv);

	gnome_vfs_init ();

	prefs = g_object_new (TYPE_SPLASH_PREFERENCES, NULL);
	gtk_dialog_run (prefs);

	gtk_main ();
}
